=== debian/changelog ===
tbb (4.4~20151115-0ubuntu3) xenial; urgency=medium

  * Build-depend on dh-exec.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2016 01:11:44 +0100

tbb (4.4~20151115-0ubuntu2) xenial; urgency=medium

  * Multiarchify the package.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Jan 2016 18:42:45 +0100

tbb (4.4~20151115-0ubuntu1) xenial; urgency=medium

  * New upstream release.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jan 2016 15:38:31 +0100

tbb (4.3~20150611-1~exp3ubuntu1) wily; urgency=medium

  * gcc-atomic-detection.patch: Fix the gcc atomic detection to work for
    gcc-5.x and up, as well as adding -latomic to LIBS (closes: #787084)
  * gcc-atomic-always.patch: Always define TBB_USE_GCC_BUILTINS for GCC.
  * debian/tbb.pc.in: Add -latomic to the pkg-config file for the above.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Aug 2015 23:21:20 -0600
